#include "sa.h"

TIMERS                    *alloc_times(); 
Energy_Type             *alloc_energy();
STUDENT                 *alloc_student();
BLD                     *alloc_building();
DEPT                    *alloc_department();
CLASS                   *alloc_class(), *alloc_class2();
PROFESSOR               *alloc_professor();
ROOM                    *alloc_room();
extern                  print_buildings_classes();
int                     init_swap2_store();
double                  init_accum_costs();
double                  init_specific_heat();

/*
 * function for memory allocation for various structure types.
 *
*/

memory_allocation()
{
int i;
  timings = alloc_times(); 

  init_accum_costs();

  init_specific_heat();

  init_swap2_store();

  saveclasses = alloc_class2();

  rooms = alloc_room();

  professors = alloc_professor();

  classes = alloc_class();

  department = alloc_department();

  build = alloc_building();

  students = alloc_student();

  return;
}

  
/*=======================================================================*/
Energy_Type * alloc_energy()
{
  Energy_Type *temp_energy_cost = NULL;

  if ((temp_energy_cost = (Energy_Type *) malloc(sizeof(Energy_Type))) == NULL)
    {
      fprintf(stderr,"CAN not allocate memeory for %s - bye!\n","energy_cost");
      fflush(stderr);
      exit(1);
    }

  temp_energy_cost->hard_cost = 0.0;
  temp_energy_cost->soft_cost = 0.0;
  temp_energy_cost->total_cost = 0.0;
  temp_energy_cost->roomsize_cost = 0.0;
  
  return(temp_energy_cost);
}

/*=======================================================================*/
STUDENT * alloc_student()
{
  STUDENT *temp_student = NULL;
  int i;

  if ((temp_student = (STUDENT *) malloc(MAXNUMSTUDENTS * sizeof(STUDENT))) == NULL)
    {
      fprintf(stderr,"Can NOT allocate memory for %s - bye!\n","students");
      fflush(stderr);
      exit(1);
    }
  strcpy(temp_student->name,"");
  temp_student->studentid = 0;
  temp_student->major = 0;
  temp_student->numb_classes_chosen = 0;
  temp_student->classcost = 0;

  memset(temp_student->class_choice, -1, CHOICELENGTH);

#if 0
  for (i = 0 ; i < CHOICELENGTH ; i++)
    temp_student->class_choice[i] = -1;
#endif

  return(temp_student);
}

/*=======================================================================*/
BLD * alloc_building()
{
  BLD *temp_build = NULL;
  int i;

  if ((temp_build = (BLD *) malloc((MAXNUMBLD + 1) * sizeof(BLD))) == NULL)
    {
      fprintf(stderr,"Can NOT allocate memory for %s - bye!\n","build");
      fflush(stderr);
      exit(1);
    }
  strcpy(temp_build->name, "");
  temp_build->class_counter = 0;
  temp_build->ptr_to_class = NULL;
  temp_build->first = NULL;
  temp_build->room_counter = 0;
  temp_build->profcost = 0.0;

  memset(temp_build->room_array, -1, MAX_NUM_ROOMS_PER_BLD);

#if 0
  for (i = 0; i < MAX_NUM_ROOMS_PER_BLD; i++)
    {
      temp_build->room_array[i] = -1;
    }
#endif

  return(temp_build);
}

/*=======================================================================*/
DEPT * alloc_department()
{
  DEPT *temp_department = NULL;
  int  i;

  if ((temp_department = (DEPT *) malloc(MAXNUMDEPT * sizeof(DEPT))) == NULL)
    {
      fprintf(stderr,"Can NOT allocate memory for %s - bye!\n","department");
      fflush(stderr);
      exit(1);
    }
  strcpy(temp_department->name, "");
  temp_department->bld_counter = 0;

  memset(temp_department->assigned_bld, -1, MAXNUMBLD);

#if 0
  for( i = 0; i < MAXNUMBLD ; i++)
    temp_department->assigned_bld[i] = -1;
#endif

  return(temp_department);
}

/*=======================================================================*/
CLASS * alloc_class()
{
  CLASS *temp_classes = NULL;
  int i;
  if ((temp_classes = (CLASS *) malloc(MAXNUMCLASSES * sizeof(CLASS))) == NULL)
    {
      fprintf(stderr,"Can NOT allocate memory for %s - bye!\n","classes");
      fflush(stderr);
      exit(1);
    }
  strcpy(temp_classes->name, "");
  strcpy(temp_classes->college, "");
  strcpy(temp_classes->prefix, "");
  temp_classes->numb_section = 0;
  strcpy(temp_classes->profname, "");
  temp_classes->maxenrollment = 0;
  temp_classes->room_capacity = 0;
  strcpy(temp_classes->bldg, "");
  strcpy(temp_classes->room_num, "");
  strcpy(temp_classes->roomtype, "");
  temp_classes->begin_time = 0;
  temp_classes->end_time = 0;
  strcpy(temp_classes->day1, "");
  strcpy(temp_classes->day2, "");
  strcpy(temp_classes->day3, "");
  temp_classes->enrollment = 0;
  temp_classes->profnumber = 0;
  temp_classes->profcost = 0.0;
  temp_classes->number = 0;
  temp_classes->rmcost = 0.0;
  temp_classes->excost = 0;
  temp_classes->excounter = 0;
  temp_classes->dept_position = 0;
  temp_classes->bld_position = 0;
  strcpy(temp_classes->bld_room, "");
  temp_classes->room_address = 0;
  temp_classes->dept_index = -1;
  temp_classes->next = NULL;

  memset(temp_classes->share_time_place, 0, CLASSES_SHARING_COST);

#if 0
  for ( i = 0; i < CLASSES_SHARING_COST; i++)
    temp_classes->share_time_place[i] = 0;
#endif

  memset(temp_classes->execlusion, -1, 500);

#if 0
  for ( i = 0; i < 500; i++)
    temp_classes->execlusion[i] = -1;
#endif

  return(temp_classes);
}

/*=======================================================================*/
CLASS * alloc_class2()
{
  CLASS *temp_classes2 = NULL;
  int i;
  if ((temp_classes2 = (CLASS *) malloc(sizeof(CLASS))) == NULL)
    {
      fprintf(stderr,"Can NOT allocate memory for %s - bye!\n","classes");
      fflush(stderr);
      exit(1);
    }
  strcpy(temp_classes2->name, "");
  strcpy(temp_classes2->college, "");
  strcpy(temp_classes2->prefix, "");
  temp_classes2->numb_section = 0;
  strcpy(temp_classes2->profname, "");
  temp_classes2->maxenrollment = 0;
  temp_classes2->room_capacity = 0;
  strcpy(temp_classes2->bldg, "");
  strcpy(temp_classes2->room_num, "");
  strcpy(temp_classes2->roomtype, "");
  temp_classes2->begin_time = 0;
  temp_classes2->end_time = 0;
  strcpy(temp_classes2->day1, "");
  strcpy(temp_classes2->day2, "");
  strcpy(temp_classes2->day3, "");
  temp_classes2->enrollment = 0;
  temp_classes2->profnumber = 0;
  temp_classes2->profcost = 0.0;
  temp_classes2->number = 0;
  temp_classes2->rmcost = 0.0;
  temp_classes2->excost = 0;
  temp_classes2->excounter = 0;
  temp_classes2->dept_position = 0;
  temp_classes2->bld_position = 0;
  strcpy(temp_classes2->bld_room, "");
  temp_classes2->room_address = 0;
  temp_classes2->dept_index = -1;
  temp_classes2->next = NULL;

  memset(temp_classes2->execlusion, -1, 500);

#if 0
  for ( i = 0; i < 500; i++)
    temp_classes2->execlusion[i] = -1;
#endif

  return(temp_classes2);
}

/*=======================================================================*/
PROFESSOR * alloc_professor()
{
  PROFESSOR *temp_professors = NULL;
  int  i;
  
  if ((temp_professors = 
       (PROFESSOR *) malloc(MAXNUMPROFS * sizeof(PROFESSOR))) == NULL)
    {
      fprintf(stderr,"Can NOT allocate memory for %s - bye!\n","professors");
      fflush(stderr);
      exit(1);
    }

  strcpy(temp_professors->name, "");
  temp_professors->nclasses = 0;

  memset(temp_professors->classnumbers, 0, MAXNUMCLASSESPERPROF);

#if 0
  for (i = 0; i < MAXNUMCLASSESPERPROF; i++)
    temp_professors->classnumbers[i] = 0;
#endif

  temp_professors->profnumber = 0;
  temp_professors->profcost = 0.0;

  return(temp_professors);
}

/*=======================================================================*/
ROOM * alloc_room()
{
  int i = 0;
  ROOM *temp_rooms = NULL;
  if ((temp_rooms = (ROOM *) malloc(PHYSICALROOMS * sizeof(ROOM))) == NULL)
    {
      fprintf(stderr,"Can NOT allocate memory for %s - bye!\n","rooms");
      fflush(stderr);
      exit(1);
    }
  
  strcpy(temp_rooms->bldg, "");
  temp_rooms->room_address = 0;
  strcpy(temp_rooms->room_num, "");
  strcpy(temp_rooms->room_type, "");
  temp_rooms->room_capacity = 0;
  strcpy(temp_rooms->room_purpose, "");
  strcpy(temp_rooms->room_priority, "");
  temp_rooms->nclasses = 0;

  memset(temp_rooms->class_array, -1, MAX_NUM_CLASSES_PER_ROOM);

#if 0
  for (i = 0; i < MAX_NUM_CLASSES_PER_ROOM; i++)
    temp_rooms->class_array[i] = -1;
#endif

  return(temp_rooms);
}

/*=======================================================================*/
TIMERS * alloc_times()
{
  TIMERS *temp_times = NULL;
  int i = 0;

  if ((temp_times = (TIMERS *) malloc(TIMESLOTS * sizeof(int))) == NULL)
    {
      fprintf(stderr,"No available memory for array %s. \n","times");
      fflush(stderr);
      exit(1);
    }

  memset(temp_times->day, 0, max_meeting_days);

#if 0
  for (i = 0; i < max_meeting_days; i++)
    temp_times->day[i] = 0;
#endif

  return(temp_times);
}

/*=======================================================================*/

int init_swap2_store()
{
  int i;

  for (i = 0; i < MAX_NUM_SWAPS; i++)
    swap2_store[i] = 0;
}

/*=======================================================================*/
double init_accum_costs()
{
  int i;
  
  for (i = 0; i < MAX_NUM_COSTS; i++)
    accum_costs[i] = 0.0;
}

/*=======================================================================*/
double init_specific_heat()
{
  int i;

  for (i = 0; i < Max_Markov_Chain; i++)
    specific_heat[i] = 0.0;
}

/*=======================================================================*/
/* This routine builds a linked list of courses. These course are not
   scheduled and are assigned to a non-existing building named "ghost".
=========================================================================*/
build_not_scheduled_courses_links()
{
int i;
#if 1

printf("classcount = %d   sched_count = %d\n", classcount, sched_count);
printf("building = %d   classes are = \n", MAXNUMBLD);
#endif
for (i = sched_count; i < classcount; i++)
  {
    if (build[MAXNUMBLD].first == NULL)
      {
	build[MAXNUMBLD].first = build[MAXNUMBLD].ptr_to_class = alloc_class2();

/**************************************************/
/* a separate routine need to handle these kind
   of assignments. A typical call will be:
         assign_values(MAXNUMBLD, i, ptr_to_class);
***************************************************/

	strcpy(build[MAXNUMBLD].ptr_to_class->name, classes[i].name);
	build[MAXNUMBLD].ptr_to_class->enrollment = classes[i].enrollment;
	build[MAXNUMBLD].ptr_to_class->number = classes[i].number;
	build[MAXNUMBLD].ptr_to_class->room_capacity = classes[i].room_capacity;
	strcpy(build[MAXNUMBLD].ptr_to_class->roomtype , classes[i].roomtype);
	strcpy(build[MAXNUMBLD].ptr_to_class->prefix, classes[i].prefix);
	build[MAXNUMBLD].ptr_to_class->numb_section = classes[i].numb_section;
	strcpy(build[MAXNUMBLD].ptr_to_class->profname, classes[i].profname);
	strcpy(build[MAXNUMBLD].ptr_to_class->day1, classes[i].day1);
	strcpy(build[MAXNUMBLD].ptr_to_class->day2, classes[i].day2);
	strcpy(build[MAXNUMBLD].ptr_to_class->day3, classes[i].day3);
	build[MAXNUMBLD].ptr_to_class->room_address = classes[i].room_address;
	build[MAXNUMBLD].ptr_to_class->begin_time = classes[i].begin_time;
	build[MAXNUMBLD].ptr_to_class->end_time   = classes[i].end_time;
	build[MAXNUMBLD].class_counter++;
	                                /* the class is not assigned to any room since
                                           we are dealing with a non-existing building
                                           here.
                                        */

#if 0
	rooms[build[MAXNUMBLD].ptr_to_class->room_address].class_array[rooms[build[MAXNUMBLD].ptr_to_class->room_address].nclasses] = 
	  build[MAXNUMBLD].ptr_to_class->number;
	rooms[build[MAXNUMBLD].ptr_to_class->room_address].nclasses++;


	printf("%d  %s  \n", i,  build[MAXNUMBLD].first->name);
#endif
      }
    else
      {
	build[MAXNUMBLD].ptr_to_class->next = alloc_class2();
	build[MAXNUMBLD].ptr_to_class = build[MAXNUMBLD].ptr_to_class->next;

/**************************************************/
/* a separate routine need to handle these kind
   of assignments. A typical call will be:
         assign_values(MAXNUMBLD, i, ptr_to_class);
***************************************************/

	strcpy(build[MAXNUMBLD].ptr_to_class->name, classes[i].name);
	build[MAXNUMBLD].ptr_to_class->enrollment = classes[i].enrollment;
	build[MAXNUMBLD].ptr_to_class->number = classes[i].number;
	build[MAXNUMBLD].ptr_to_class->room_capacity = classes[i].room_capacity;
	strcpy(build[MAXNUMBLD].ptr_to_class->roomtype, classes[i].roomtype);
	strcpy(build[MAXNUMBLD].ptr_to_class->prefix, classes[i].prefix);
	build[MAXNUMBLD].ptr_to_class->numb_section = classes[i].numb_section;
	strcpy(build[MAXNUMBLD].ptr_to_class->profname, classes[i].profname);
	strcpy(build[MAXNUMBLD].ptr_to_class->day1, classes[i].day1);
	strcpy(build[MAXNUMBLD].ptr_to_class->day2, classes[i].day2);
	strcpy(build[MAXNUMBLD].ptr_to_class->day3, classes[i].day3);
	build[MAXNUMBLD].ptr_to_class->room_address = classes[i].room_address;
	build[MAXNUMBLD].ptr_to_class->begin_time = classes[i].begin_time;
	build[MAXNUMBLD].ptr_to_class->end_time   = classes[i].end_time;
	build[MAXNUMBLD].class_counter++;
	                                /* the class is not assigned to any room since
                                           we are dealing with a non-existing building
                                           here.
                                        */

#if 0
	rooms[build[MAXNUMBLD].ptr_to_class->room_address].class_array[rooms[build[MAXNUMBLD].ptr_to_class->room_address].nclasses] = 
	   build[MAXNUMBLD].ptr_to_class->number;
	rooms[build[MAXNUMBLD].ptr_to_class->room_address].nclasses++;
	
	printf("%d  %s \n", i,  build[MAXNUMBLD].ptr_to_class->name);
#endif
      }
  }
if (build[MAXNUMBLD].class_counter == 1)
  {
    build[MAXNUMBLD].ptr_to_class = build[MAXNUMBLD].first;
    build[MAXNUMBLD].ptr_to_class->next = 
      build[MAXNUMBLD].first->next  =  NULL;
  }
else
  {
    if (build[MAXNUMBLD].class_counter == 0)
      {
	build[MAXNUMBLD].ptr_to_class = 
	  build[MAXNUMBLD].first = NULL;
      }
    else
      build[MAXNUMBLD].ptr_to_class->next = NULL;  
  }
return;
}

/*
 *
 * This routines builds and also adds cells of courses to already 
 * existing linked lists. All of the courses added here are already scheduled
 * and assigned to existing buildings.
 *
 */

construct_building_to_scheduled_courses_links()
{
  int position1 = 0, position2 = 0, i = 0, j = 0, k = 0, x = 0;
 
/*---------------------------------------------
   To link dept[i] ---> building[j] ---> classes[k], we need the
   following classes[k] fields:
   classes[k].bldg  and  classes[k].college from file
           scheduled-classes.last.last
-----------------------------------------------*/

printf("===============test in===============\n");
  for (i = 0; i < sched_count ; i++)
    {
      position1 = classes[i].dept_position;
      position2 = classes[i].bld_position;

/*-------------------------------------------------
Note: we also could refer to the chosen building as:
      build[department[position1].assigned_bld[postion2]].ptr_to_class 
      But, it would be more straight forward to just use position2.
---------------------------------------------------*/
     if (build[position2].first == NULL)
       {

	 build[position2].first = 
	   build[position2].ptr_to_class = alloc_class2();

	 build[position2].ptr_to_class->number = classes[i].number;
	 strcpy(build[position2].ptr_to_class->college, classes[i].college);
	 strcpy(build[position2].ptr_to_class->prefix, classes[i].prefix);
	 build[position2].ptr_to_class->numb_section = classes[i].numb_section;
	 strcpy(build[position2].ptr_to_class->name, classes[i].name);
	 strcpy(build[position2].ptr_to_class->profname, classes[i].profname);
	 build[position2].ptr_to_class->enrollment = classes[i].enrollment;
	 build[position2].ptr_to_class->maxenrollment = classes[i].maxenrollment;
	 strcpy(build[position2].ptr_to_class->bldg, classes[i].bldg);
	 strcpy(build[position2].ptr_to_class->room_num, classes[i].room_num);
	 build[position2].ptr_to_class->room_capacity = classes[i].room_capacity;
	 build[position2].ptr_to_class->begin_time = classes[i].begin_time;
	 build[position2].ptr_to_class->end_time = classes[i].end_time;
	 strcpy(build[position2].ptr_to_class->day1, classes[i].day1);
	 strcpy(build[position2].ptr_to_class->day2, classes[i].day2);
	 strcpy(build[position2].ptr_to_class->day3, classes[i].day3);
	 strcpy(build[position2].ptr_to_class->roomtype, classes[i].roomtype);
	 build[position2].ptr_to_class->rmcost = classes[i].rmcost;
	 build[position2].ptr_to_class->dept_position = classes[i].dept_position;
	 build[position2].ptr_to_class->bld_position = classes[i].bld_position;
	 build[position2].ptr_to_class->room_address = classes[i].room_address;
	 strcpy(build[position2].ptr_to_class->bld_room, classes[i].bld_room);
	 build[position2].class_counter++;

#if 0
	 rooms[build[position2].ptr_to_class->room_address].class_array[rooms[build[position2].ptr_to_class->room_address].nclasses] = 
	   build[position2].ptr_to_class->number;
	 
	 rooms[build[position2].ptr_to_class->room_address].nclasses++;	 
printf("building = %d,  class = %s \n", position2, build[position2].first->name);
#endif

	 build[position2].ptr_to_class->next = NULL;
       }
     else
       {
	 
	 build[position2].ptr_to_class->next = alloc_class2();
	 
	 build[position2].ptr_to_class = build[position2].ptr_to_class->next; 
	 build[position2].ptr_to_class->number = classes[i].number;
	 strcpy(build[position2].ptr_to_class->college, classes[i].college);
	 strcpy(build[position2].ptr_to_class->prefix, classes[i].prefix);
	 build[position2].ptr_to_class->numb_section = classes[i].numb_section;
	 strcpy(build[position2].ptr_to_class->name, classes[i].name);
	 strcpy(build[position2].ptr_to_class->profname, classes[i].profname);
	 build[position2].ptr_to_class->enrollment = classes[i].enrollment;
	 build[position2].ptr_to_class->maxenrollment = classes[i].maxenrollment;
	 strcpy(build[position2].ptr_to_class->bldg, classes[i].bldg);
	 strcpy(build[position2].ptr_to_class->room_num, classes[i].room_num);
	 build[position2].ptr_to_class->room_capacity = classes[i].room_capacity;
	 build[position2].ptr_to_class->begin_time = classes[i].begin_time;
	 build[position2].ptr_to_class->end_time = classes[i].end_time;
	 strcpy(build[position2].ptr_to_class->day1, classes[i].day1);
	 strcpy(build[position2].ptr_to_class->day2, classes[i].day2);
	 strcpy(build[position2].ptr_to_class->day3, classes[i].day3);
	 strcpy(build[position2].ptr_to_class->roomtype, classes[i].roomtype);
	 build[position2].ptr_to_class->rmcost = classes[i].rmcost;
	 build[position2].ptr_to_class->dept_position = classes[i].dept_position;
	 build[position2].ptr_to_class->bld_position = classes[i].bld_position;
	 build[position2].ptr_to_class->room_address = classes[i].room_address;
	 strcpy(build[position2].ptr_to_class->bld_room, classes[i].bld_room);
	 build[position2].class_counter++;

#if 0
	 rooms[build[position2].ptr_to_class->room_address].class_array[rooms[build[position2].ptr_to_class->room_address].nclasses] = 
	   build[position2].ptr_to_class->number;
	 
	 rooms[build[position2].ptr_to_class->room_address].nclasses++;
	 printf("building = %d,  head class = %s,  class = %s \n", 
	     position2, build[position2].first->name, build[position2].ptr_to_class->name);
#endif

	 build[position2].ptr_to_class->next = NULL;

       }
    }
  for (i = 0; i < MAXNUMBLD; i++)
    {
      if (build[i].class_counter == 1)
	{
	  build[i].ptr_to_class = build[i].first;
	  build[i].ptr_to_class->next = build[i].first->next = NULL;
	}
      else
	{
	  if (build[i].class_counter == 0)
	    {
	      build[i].ptr_to_class = build[i].first = NULL;
	    }
	}
    }
#if 1
printf("===============test out===============\n");
#endif
  return;
}

/*========================================================================
 * Function:  Convert dept-building of the state matrix into  
 *          dept-->building-->class link list.  The starting point is an 
 *          array of departments (named department), each of type structure,
 *	    and each has an array field (named assigned_bld) to hold an index 
 *    in (0 ... MAXNUMBLD+1) of the (build) array of buildings structures.
 * Called by: main(). 
 * Calls: none.
 * Returns: none.
 =========================================================================*/
create_department_building_structure()
{
  int i, j;

  for (i = 0; i < MAXNUMDEPT; i++)
    department[i].bld_counter= 0;

  for (i = 0; i < MAXNUMDEPT; i++)
    {
      strcpy(department[i].name, dept[i]);
      
      for (j = 0; j < MAXNUMBLD; j++)
	{
	  if (state_matrix_slot[i][j] != 0)
	    {
	      department[i].assigned_bld[department[i].bld_counter] = j;
	                                            /* as new building index is added, 
                                                       increment the building counter of
                                                       that department. */
	      department[i].bld_counter++;
	    }
	}
      department[i].assigned_bld[department[i].bld_counter++] = MAXNUMBLD;
    }
/*-------------------------------
  Insert in the array of structures (build) the name of each
  building.
---------------------------------*/
  for (j = 0; j < MAXNUMBLD; j++)
    {
      strcpy(build[j].name, building[j]);
    }
  return;
}


/*
 * Function: reads in two files, the scheduled classes and non-schedules
 * classes one.
 * Called by: main().  Calls: build_not_scheduled_courses_links() ,
 * assign_dept_building_position().
 *
 */

load_data_classes()
{
  FILE            *fptr= NULL, *fptrf = NULL;
  int             i = 0, class_section, enroll, fromtime, totime, roomcapacity,
                  tmpint = 0, j = 0, tmp = 0, flag1 = 0, flag2 = 0, c1 = 0,
                  c2 = 0;

  CLASS           *ptr = NULL;

  char            classchar[10], prefixchar[4], profchar[30], roomchar[15],
                  day1char[4], day2char[4], day3char[4], 
                  collegechar[4], bldgchar[15], temp_char1[2], temp_char2[2];

/*-----------------(1)---------------------*/
/* Read Class Numbers And Names from File  */
/* class number, class name (or prefix).   */
/*-----------------------------------------*/
        i = sched_count = 0;
        classcount = 0;
        if ((fptr = fopen("Sch.NEW","r")) == NULL)
         {
           fprintf(stderr,"Cannot open %s  - bye!\n","Sch.NEW");
	   fflush(stderr);
           exit(1);
         }              
	while (fscanf(fptr, "%d   %d   %s   %s   %d   %s   %s   %d   %s   %s   %s   %d   %d   %d   %s  %s   %s   %d", 
		      &(classes[i].number), &tmpint,  collegechar, prefixchar, 
		      &class_section, classchar, profchar, &enroll, bldgchar, 
		      roomchar, classes[i].bld_room, &roomcapacity, &fromtime, 
		      &totime, day1char, day2char, day3char, 
		      &(classes[i].room_address)) != EOF) {
	   classcount++;
	   sched_count++ ;
	   strcpy(classes[i].college, collegechar);
	   strcpy(classes[i].prefix, prefixchar);
	   classes[i].numb_section  = class_section;
	   strcpy(classes[i].name, classchar);
	   strcpy(classes[i].profname, profchar);
	   classes[i].enrollment    = enroll;
	   classes[i].maxenrollment = enroll;
	   strcpy(classes[i].bldg, bldgchar);
	   strcpy(classes[i].room_num, roomchar);
	   classes[i].room_capacity = roomcapacity;
	   classes[i].begin_time    = fromtime;
	   classes[i].end_time      = totime;
	   strcpy(classes[i].day1, day1char);
	   strcpy(classes[i].day2, day2char);
	   strcpy(classes[i].day3, day3char);
/*
 * There is another nclasses counter in the function
 * (construct_build_to_scheduled_courses_links).
 *
 */
#if 0
	   tmp = rooms[classes[i].room_address].nclasses;
	   rooms[classes[i].room_address].class_array[tmp] =
	     classes[i].number;
	   rooms[classes[i].room_address].nclasses++;
#endif

	  for (j = 0; j < MAXNUMDEPT; j++)
	    {
	      if (strcmp(classes[i].prefix, dept[j]) == 0)
		{
		  classes[i].dept_position = j;
		  break;
		}
	    }

	  for (j = 0; j < MAXNUMBLD; j++)
	    {
	      if (strcmp(classes[i].bldg, building[j]) == 0)
		{
		  classes[i].bld_position = j;
		  break;
		}
	    }

	   i++;
	 }
        fclose(fptr); 

	printf("...........scheduled classes read = %d\n", sched_count);

	printf("...........scheduled classes + 1 = %d\n", i);

/*-------------------------*/
	construct_building_to_scheduled_courses_links();
/*-------------------------*/

        if ((fptr = fopen("NO-Sch.NEW","r")) == NULL)
         {
           fprintf(stderr,"Cannot open %s  - bye!\n", "NO-Sch.NEW");
	   fflush(stderr);
           exit(1);
         }
	not_sched_count = 0;

  while (fscanf(fptr, "  %d  %d  %s  %s  %d  %s  %d  %s  %d  %d  %s  %s  %s", 
		&(classes[i].number), &tmpint, classchar, prefixchar, 
		&class_section, profchar, &enroll, roomchar, &fromtime, 
		&totime, day1char, day2char, day3char) != EOF) {
#if 1
    printf("inside Not-sched ==== record num  %d  just read: %d\n", i, classes[i].number);
#endif
          classcount++;
	  not_sched_count++;
          strcpy(classes[i].name, classchar);
          strcpy(classes[i].prefix, prefixchar);
          classes[i].numb_section  = class_section;
          strcpy(classes[i].profname, profchar);
          classes[i].maxenrollment = enroll;
          classes[i].enrollment = enroll;
          strcpy(classes[i].roomtype, roomchar);
          classes[i].begin_time    = fromtime;
          classes[i].end_time      = totime;
          strcpy(classes[i].day1, day1char);
          strcpy(classes[i].day2, day2char);
          strcpy(classes[i].day3, day3char);
#if 1
printf(" day3 = %s\n", classes[i].day2);
#endif
	  for (j = 0; j < MAXNUMDEPT; j++)
	    {
	      if (strcmp(classes[i].prefix, dept[j]) == 0)
		{
		  classes[i].dept_position = j;
		  break;
		}
	    }
          classes[i].bld_position = MAXNUMBLD;
          i++;
        }
        fclose(fptr);
	printf("..........not scheduled classes read = %d\n", not_sched_count);

/*-------------------------*/
	build_not_scheduled_courses_links();
/*-------------------------*/
  load_data7();
/*-------------------------*/

  for (i = 0; i < exclusionpaircount; i++)
    {
      c1 = exclusionpairs[i][0];
      c2 = exclusionpairs[i][1];

      flag1 = flag2 = 0;

      for (j = 0; j < MAXNUMBLD ; j++)
	{
	  ptr = build[j].first;
	  while(ptr != NULL)
	    {
	      if (ptr->number == c1)
		{
		  ptr->execlusion[ptr->excounter++] = c2;
		  flag1 = 1;
		  break;
		}
	      ptr = ptr->next;
	    }
	  ptr = build[j].first;
	  while(ptr != NULL)
	    {
	      if (ptr->number == c2)
		{
		  ptr->execlusion[ptr->excounter++] = c1;
		  flag2 = 1;
		  break;
		}
	      ptr = ptr->next;

	    }
	  if (flag1 && flag2)
	    break;
	}
    }
  return;
}
/*-------------(3)-----------------------------*/
/* Read Professors Numbers and Names from File */
/* format: prof number, prof name.             */
/*---------------------------------------------*/
load_data3()
{
  FILE  *fptr = NULL, *fptrf = NULL;
  int i = 0;
  profcount = 0;

        if ((fptr = fopen("professors.DATA","r")) == NULL)
         {
           fprintf(stderr,"Cannot open %s  - bye!\n","professors.DATA");
	   fflush(stderr);
           exit(1);
         }              
/*---------------
   tmpint: is the professor number 
   (assuming it is in a sequential order). 
   tmpchar: professor name. Here, also we will assume that
   number of classes taught by the professor is initialized
   to zero. 
----------------*/

        while (fscanf(fptr, "%d  %s", 
                      &(professors[i].profnumber), professors[i].name ) != EOF) {
          professors[i].nclasses = 0;
          i++;
        }
        fclose(fptr);
        profcount = i;
}

/*--------------------(4)------------------------------*/
/* Read Class Enrollments from File                    */
/* class number, enrollments size.                     */
/*-----------------------------------------------------*/
/* tmpint1: the class number (sequentially).           */
/* tmpint2: the size of that class.                    */
/*-----------------------------------------------------*/
load_data4()
{
    FILE  *fptr = NULL, *fptrf = NULL;
    int   i = 0, tmpint1,  tmpint2;

        if ((fptr = fopen("enrollment.DATA","r")) == NULL)
          {
            fprintf(stderr,"Cannot open %s  - bye!\n","enrollment.DATA");
	    fflush(stderr);
            exit(1);
          }              
        while (fscanf(fptr, "%d   %d", &tmpint1, &tmpint2) != EOF) 
          {
            classes[i].number = tmpint1;
            classes[i].maxenrollment = classes[classes[i].number].enrollment = tmpint2;
            i++;
          }
    fclose(fptr);
  }

/*------------------(5)-------------------------*/
/* Read Professor/Class Assignments from File   */
/* class number, the assigned professor number. */
/*----------------------------------------------*/
load_data5()
{
FILE  *fptr = NULL;
int   i = 0,  tmpint1,  tmpint2;

/* tmpint: the class number (sequentially). tmpint2:
   number of the professor assigned to the given
   class. */

        if ((fptr = fopen("class-prof.DATA","r")) == NULL)
          {
            fprintf(stderr,"Cannot open %s  - bye!\n","class-prof.DATA");
	    fflush(stderr);
            exit(1);
          }              
        while (fscanf(fptr, "%d  %d", &tmpint1, &tmpint2) != EOF)
          {
            classes[i].profnumber = tmpint2;
            professors[tmpint2].classnumbers[professors[tmpint2].nclasses] = tmpint1;
            professors[tmpint2].nclasses++;
            i++;
          }
fclose(fptr);
}

/*----------------------(6)------------------------------------*/
/* Read Classroom Attributes from File                         */
/* room number, capacity, presence of AV equipments (5 types). */
/*-------------------------------------------------------------*/
load_data6()
{
 FILE  *fptr = NULL;
 int   i = 0, j = 0;

 roomcount = 0;
 if ((fptr = fopen("rooms.DATA","r")) == NULL)
   {
     fprintf(stderr,"Cannot open %s  - bye!\n","rooms.DATA");
     fflush(stderr);
     exit(1);
   }              
 while (fscanf(fptr, "%d %s %s %s %d %s %s %s", 
	       &(rooms[i].room_address), rooms[i].bldg, rooms[i].room_num, 
	       rooms[i].bld_room, &(rooms[i].room_capacity), rooms[i].room_type, 
	       rooms[i].room_purpose, rooms[i].room_priority) != EOF) {    
 
   rooms[i].nclasses = 0;

   for (j = 0; j < MAXNUMBLD; j++)
     {
       if (strcmp(rooms[i].bldg, build[j].name) == 0)
	 {
	   build[j].room_array[build[j].room_counter] = 
	     rooms[i].room_address;
	   build[j].room_counter++;
	   break;
	 }
     }
   i++;
 }
 fclose(fptr);
 roomcount = i;
}

/*========= check_on_building_room() MAY NOT be Needed ============
 *
 * For each building (in the build structure), for all existing rooms,
 * if the building name is the same as the name of building of the current
 * room: add room_address to the room_array of the cuurent building.
 *
*/

check_on_building_room()
{
  int i = 0, j = 0, k = 0;

  print_buildings_classes();
  for (i = 0; i < roomcount; i++)
    {
      k = 0;
      for (j = 0; j < MAXNUMBLD; j++)
	{
	  if (strcmp(rooms[i].bldg, build[j].name) == 0)
	    {
              k = build[j].room_counter;
              build[j].room_array[k] = rooms[i].room_address;
	      build[j].room_counter++;
              break;
            }
	}
    }
  print_buildings_classes();
  return;
}

/*------------------------(7)------------------------------------*/
/* Read Class pairs that can't happen at same time               */
/* class number (sequential tag), class number (sequential tag). */
/*---------------------------------------------------------------*/
load_data7()
{
  FILE  *fptr = NULL;
  int   i = 0;

  exclusionpaircount = 0;
  if ((fptr = fopen("execlusive.DATA","r")) == NULL)
    {
      fprintf(stderr,"Cannot open %s  - bye!\n","execlusive.DATA");
      fflush(stderr);
      exit(1);
    }              
  while (fscanf(fptr, "%d   %d",  exclusionpairs[i],  exclusionpairs[i]+1) != EOF) {
    exclusionpaircount++;
    i++;
  }
  fclose(fptr);
}

/*-----------------------------(8)-------------------------------------*/
/* read annealing parameters                                           */
/* cooling factor, temp, iter_per_timestep, exp_value, boltzman_value. */
/*---------------------------------------------------------------------*/
load_data8()
{
  FILE  *fptr = NULL;

  if ((fptr = fopen("parameters.DATA","r")) == NULL)
    {
      fprintf(stderr,"Cannot open %s  - bye!\n","parameters.DATA");
      fflush(stderr);
      exit(1);
    }              
  fscanf(fptr, "%lf ", &cooling_factor);
  fscanf(fptr, "%lf ", &temperature);

  fscanf(fptr, "%d ",  &iters_per_timestep);  /* inner loop */
  fscanf(fptr, "%d ",  &timesteps);           /* outer loop */

  fscanf(fptr, "%lf ", &exp_value);
  fscanf(fptr, "%lf ", &boltzmann_value);
  fclose(fptr);
}

/*----------(9)------------------------------------------------------*/
/* Read students records from File.                                  */
/* name, ssn, major, numb of classes,  choice classes.               */
/*-------------------------------------------------------------------*/
load_data9()
{
  FILE  *fptr = NULL, *fptrf = NULL;
  int   i = 0, tmpint_0, tmpint_1, tmpint_2, tmpint_3, tmpint_4, tmpint_5,
  tmpint_6, tmpint_7, tmpint_8, tmpint_9, tmpint_10, tmpint_11, tmpint_12,
  tmpint_13;
  studentcount = 0;

  if ((fptr = fopen("students.DATA","r")) == NULL)
    {
      fprintf(stderr,"Cannot open %s  - bye!\n","students.DATA");
      fflush(stderr);
      exit(1);
    }              
  while (fscanf(fptr,"%s %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
		students[i].name, 
		&(students[i].studentid),
		&(students[i].major),
		&(students[i].numb_classes_chosen),
		&tmpint_0, &tmpint_1, &tmpint_2, &tmpint_3,
		&tmpint_4, &tmpint_5, &tmpint_6, &tmpint_7,
		&tmpint_8, &tmpint_9, &tmpint_10, &tmpint_11,
		&tmpint_12, &tmpint_13) != EOF)
    { 
      students[i].class_choice[0]= tmpint_0;
      students[i].class_choice[1]= tmpint_1;
      students[i].class_choice[2]= tmpint_2;
      students[i].class_choice[3]= tmpint_3;
      students[i].class_choice[4]= tmpint_4;
      students[i].class_choice[5]= tmpint_5;
      students[i].class_choice[6]= tmpint_6;
      students[i].class_choice[7]= tmpint_7;
      students[i].class_choice[8]= tmpint_8;
      students[i].class_choice[9]= tmpint_9;
      students[i].class_choice[10]= tmpint_10;
      students[i].class_choice[11]= tmpint_11;
      students[i].class_choice[12]= tmpint_12;
      students[i].class_choice[13]= tmpint_13;
      i++;
    }
  studentcount = i;
  fclose(fptr);
}

/*=======================================================================*/
load_data()
{
  load_data3();
  load_data4();
  load_data5();
  load_data6();
  load_data8();
  load_data9();

#if 1
  check_on_building_room();
#endif
  return;
}

/*
 * FUNCTION: read 2 matrices, one representing real distances between
 * buildings and the other is the states matrix. An array of real distances
 * is built out of this data. Input: distances.DAT and states.DAT files.
 * Return: none. Called by: main().  Calls: none. 
*/

read_matrices_and_create_distances()
{
  FILE    *fptr1 = NULL, *fptr2 = NULL;
  char    tmpdept[STRLENGTH],  tmpbuilding[STRLENGTH];
  int     j = 0; 
  int     i = 0;
  
  if ((fptr2 = fopen("distances.DAT","r")) == NULL)
    {
      perror("Can not open file : distances.DAT");
    }

  fscanf(fptr2,
	 "%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s\n", 
	 building[0], building[1], building[2], building[3], building[4], building[5], 
	 building[6], building[7], building[8], building[9], building[10], building[11], 
	 building[12], building[13], building[14], building[15], building[16], building[17], 
	 building[18], building[19], building[20], building[21], building[22], building[23], 
	 building[24], building[25], building[26], building[27], building[28], building[29], 
	 building[30], building[31], building[32], building[33], building[34], building[35], 
	 building[36], building[37], building[38], building[39], building[40], building[41]);
  while (fscanf(fptr2,
		"%s %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d\n",
		tmpbuilding, 
		&(real_distance[j][0]), &(real_distance[j][1]), &(real_distance[j][2]),
		&(real_distance[j][3]), &(real_distance[j][4]), &(real_distance[j][5]), 
		&(real_distance[j][6]), &(real_distance[j][7]), &(real_distance[j][8]), 
		&(real_distance[j][9]), &(real_distance[j][10]), &(real_distance[j][11]),
		&(real_distance[j][12]), &(real_distance[j][13]), &(real_distance[j][14]),
		&(real_distance[j][15]), &(real_distance[j][16]), &(real_distance[j][17]), 
		&(real_distance[j][18]), &(real_distance[j][19]), &(real_distance[j][20]), 
		&(real_distance[j][21]), &(real_distance[j][22]), &(real_distance[j][23]), 
		&(real_distance[j][24]), &(real_distance[j][25]), &(real_distance[j][26]), 
		&(real_distance[j][27]), &(real_distance[j][28]), &(real_distance[j][29]), 
		&(real_distance[j][30]), &(real_distance[j][31]), &(real_distance[j][32]), 
		&(real_distance[j][33]), &(real_distance[j][34]), &(real_distance[j][35]), 
		&(real_distance[j][36]), &(real_distance[j][37]), &(real_distance[j][38]), 
		&(real_distance[j][39]), &(real_distance[j][40]), &(real_distance[j][41])) != EOF) {
    j++;
  }
  fclose(fptr2);
  
  if ((fptr1 = fopen("states.DAT","r")) == NULL)
    {
      perror("Can not open file : states.DAT");
    }              
  fscanf(fptr1,
	 "%s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s %s\n", 
	 building[0], building[1], building[2], building[3], building[4], building[5], 
	 building[6], building[7], building[8], building[9], building[10], building[11], 
	 building[12], building[13], building[14], building[15], building[16], building[17], 
	 building[18], building[19], building[20], building[21], building[22], building[23], 
	 building[24], building[25], building[26], building[27], building[28], building[29], 
	 building[30], building[31], building[32], building[33], building[34], building[35], 
	 building[36], building[37], building[38], building[39], building[40], building[41]);

  j = 0;

  while (
	 fscanf(fptr1,
		"%s %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d\n",
		tmpdept, &state[0], &state[1], &state[2], &state[3], &state[4], &state[5], 
		&state[6], &state[7], &state[8], &state[9], &state[10], &state[11], &state[12], 
		&state[13], &state[14], &state[15], &state[16], &state[17], &state[18], 
		&state[19], &state[20], &state[21], &state[22], &state[23], &state[24], 
		&state[25], &state[26], &state[27], &state[28], &state[29], &state[30], 
		&state[31], &state[32], &state[33], &state[34], &state[35], &state[36], 
		&state[37], &state[38], &state[39], &state[40], &state[41]) != EOF) {

    strcpy(dept[j], tmpdept);

    for (i=0; i < MAXNUMBLD; i++)
      {
	if (state[i] == 1)
	  home_building[j] = i;
      }
    for (i=0; i < MAXNUMBLD; i++)
      {
	if (state[i] == 0)
	  {
	    state_distance[j][i] = 99999;
	  }
	else
	  {
	    if (state[i] == 1)
	      {
		state_distance[j][i] = 1;
	      }
	    else
	      {
		state_distance[j][i] = real_distance[home_building[j]][i];
	      }
	  }
	state_matrix_slot[i][j] = state[i];
      }
    j++;
  }
  fclose(fptr1);
}

/*
 *
 * Called by: main().  Calls: none.
 *
 */
write_schedule()
{
  int    time_only = 0, i = 0, j = 0, k = 0, count = 0;
  CLASS  *ptr = NULL;
  FILE   *fptr10 = NULL;

  fptr10 = 
    fopen("Adaptive-Output","w");
#if 0
  for (i = 0; i < studentcount; i++)
    { 
      fprintf(fptr10,"Student_name: %s\n ", students[i].name);
      fprintf(fptr10,"Student_ID: %ld\n ", students[i].studentid);
      fprintf(fptr10,"Major: %d\n ", students[i].major);
      fprintf(fptr10,"Number of classes chosen: %d\n ", 
	      students[i].numb_classes_chosen);
      fprintf(fptr10,"The student class choices: \n");
      
      for(j = 0; j < students[i].numb_classes_chosen; j++)
	fprintf(fptr10,"%d  ", students[i].class_choice[j]);

      fprintf(fptr10,"The student class cost = %d\n", 
	      students[i].classcost);
      fprintf(fptr10,"\n");
      fprintf(fptr10,"\n===================================\n");
    }
#endif

#if 0
  for (i = 0; i < roomcount; i++) {
    for(j = 0; j < TIMESLOTS; j++) {       /* timeslots per day */
      for( k=0; k < classcount; k++) {
	if ((classes[k].time == j ) && (classes[k].room == i )) 
	  {  /*   i<-->j  the time and space coincide. */
	    printf("Class Timeslot (randomly assigned initially): %d\n", 
		   classes[k].time);
	    printf("Class begin time: %d\n", classes[k].begin_time);
	    printf("Class end times: %d\n", classes[k].end_time);
	    printf("Class's room type: %s\n", classes[k].roomtype);
	    printf("Class's actual room number: %s\n", classes[k].room_num);
	    printf("Class's first day: %s\n", classes[k].day1);
	    printf("Class's second day: %s\n", classes[k].day2);
	    printf("Class's third day: %s\n", classes[k].day3);
	    printf("Room number: %d\t  Room Size: %d\n",
		   classes[k].room,rooms[classes[k].room].room_capacity);
	    if (classes[k].enrollment > rooms[classes[k].room].room_capacity)
	      printf("WARNING: OVER CAPACITY\n");
	    printf("Enrollment: %d\n",classes[k].enrollment);
	    printf("Professor number: %s\n",professors[classes[k].profnumber]);
	    printf("Current class serial number: %d   (Previous class serial number: %d)\n",
		   classes[k].number, k);
	    printf("Class_name: %s\n", classes[k].name);
	    printf("Room(xxxx)(y) [xxxxy]: %d  \n\n", classes[k].troom); 
	  }
      }
    }
#endif

#if 0
    for (i = 0; i < MAXNUMBLD; i++) 
      {
	printf("\n============ Building (%d) classes ===============\n", i);
	ptr = NULL;
	ptr = build[i].first;
	while (ptr && (ptr != ptr->next))
	  {
	    printf("Class name: %s\n", ptr->name);
	    printf("Class index: %d\n", ptr->number);
	    printf("Class professor name: %s\n", ptr->profname);
	    printf("Class enrollment: %d\n", ptr->enrollment);
	    printf("Class begin time: %d\n", ptr->begin_time);
	    printf("Class end times: %d\n",  ptr->end_time);
	    printf("Class's room type: %s\n", 
		   rooms[ptr->room_address].room_type);
	    printf("Class's actual room: %s\n", ptr->room_num);
	    printf("Class's building: %s\n", ptr->bldg);
	    printf("Class's first day: %s\n", ptr->day1);
	    printf("Class's second day: %s\n", ptr->day2);
	    printf("Class's third day: %s\n", ptr->day3);
	    printf("Class's room index: %d\n", ptr->room_address);
	    printf("Class's room size: %d\n", 
		   rooms[ptr->room_address].room_capacity);
	    if (ptr->enrollment > rooms[ptr->room_address].room_capacity)
	      printf("WARNING: OVER CAPACITY\n");
	    printf("Room:  %s  has  %d  classes assigned to it.\n\n", 
		   rooms[ptr->room_address].room_num, 
		   rooms[ptr->room_address].nclasses);
	    ptr = ptr->next;
	  }
      }
    ptr = NULL;
    ptr = build[MAXNUMBLD].first;
    while (ptr && (ptr != ptr->next))
      {
	printf("Class name: %s\n", ptr->name);
	printf("Class index: %d\n", ptr->number);
	printf("Class professor name: %s\n", ptr->profname);
	printf("Class enrollment: %d\n", ptr->enrollment);
	printf("Class begin time: %d\n", ptr->begin_time);
	printf("Class end times: %d\n",  ptr->end_time);
	printf("Class's room type: %s\n", 
	       rooms[ptr->room_address].room_type);
	printf("Class's actual room: %s\n", ptr->room_num);
	printf("Class's building: %s\n", ptr->bldg);
	printf("Class's first day: %s\n", ptr->day1);
	printf("Class's second day: %s\n", ptr->day2);
	printf("Class's third day: %s\n", ptr->day3);
	printf("Class's room index: %d\n", ptr->room_address);
	printf("Class's room size: %d\n", 
	       rooms[ptr->room_address].room_capacity);
	printf("-----------------------------\n");
	ptr = ptr->next;
      }
#endif
#if 0
    count = 0;
    for (i = 0; i < MAXNUMBLD; i++) 
      {
	fprintf(fptr10,"\n======= Building (%d) classes =========\n", i);
	ptr = NULL;
	ptr = build[i].first;
	while (ptr && (ptr != ptr->next))
	  {
	    fprintf(fptr10,"Class name: %s\n", ptr->name);
	    fprintf(fptr10,"Class index: %d\n", ptr->number);
	    fprintf(fptr10,"Class professor name: %s\n", ptr->profname);
	    fprintf(fptr10,"Class enrollment: %d\n", ptr->enrollment);
	    fprintf(fptr10,"Class begin time: %d\n", ptr->begin_time);
	    fprintf(fptr10,"Class end times: %d\n",  ptr->end_time);
	    fprintf(fptr10,"Class's room type: %s\n", 
		    rooms[ptr->room_address].room_type);
	    fprintf(fptr10,"Class's actual room: %s\n", ptr->room_num);
	    fprintf(fptr10,"Class's building: %s\n", ptr->bldg);
	    fprintf(fptr10,"Class's first day: %s\n", ptr->day1);
	    fprintf(fptr10,"Class's second day: %s\n", ptr->day2);
	    fprintf(fptr10,"Class's third day: %s\n", ptr->day3);
	    fprintf(fptr10,"Class's room index: %d\n", ptr->room_address);
	    fprintf(fptr10,"Class's room size: %d\n", 
		    rooms[ptr->room_address].room_capacity);
	    if (ptr->enrollment > rooms[ptr->room_address].room_capacity)
	      fprintf(fptr10,"WARNING: OVER CAPACITY\n");
	    fprintf(fptr10,"Room:  %s  has  %d  classes assigned to it.\n\n", 
		    rooms[ptr->room_address].room_num, 
		    rooms[ptr->room_address].nclasses);
	    count += rooms[ptr->room_address].nclasses;
	    ptr = ptr->next;
	  }
      }
    fprintf(fptr10,"Total classes assigned to given bldgs = %d\n", count);
    count = 0;
    ptr = NULL;
    ptr = build[MAXNUMBLD].first;
    while (ptr && (ptr != ptr->next))
      {
	fprintf(fptr10,"Class name: %s\n", ptr->name);
	fprintf(fptr10,"Class index: %d\n", ptr->number);
	fprintf(fptr10,"Class professor name: %s\n", ptr->profname);
	fprintf(fptr10,"Class enrollment: %d\n", ptr->enrollment);
	fprintf(fptr10,"Class begin time: %d\n", ptr->begin_time);
	fprintf(fptr10,"Class end times: %d\n",  ptr->end_time);
	fprintf(fptr10,"Class's room type: %s\n", 
		rooms[ptr->room_address].room_type);
	fprintf(fptr10,"Class's actual room: %s\n", ptr->room_num);
	fprintf(fptr10,"Class's building: %s\n", ptr->bldg);
	fprintf(fptr10,"Class's first day: %s\n", ptr->day1);
	fprintf(fptr10,"Class's second day: %s\n", ptr->day2);
	fprintf(fptr10,"Class's third day: %s\n", ptr->day3);
	fprintf(fptr10,"Class's room index: %d\n", ptr->room_address);
	fprintf(fptr10,"Class's room size: %d\n", 
		rooms[ptr->room_address].room_capacity);
	fprintf(fptr10,"-----------------------------\n");
	ptr = ptr->next;
	count += 1;
      }
    fprintf(fptr10,"Total classes assigned to the ghost bldg = %d\n", count);
    fclose(fptr10);
#endif
#if 0
    printf("\n===============================\n");
    for (i= 0; i < studentcount; i++) 
      {
	printf("student_ID (SSN): %ld\n", students[i].studentid);
	for (j = 0; j < students[i].numb_classes_chosen; j++) 
	  {
	    printf("class_choice: %d  Prof_name: %s  Room_number: %d   Class_time: %d\n", 
		   j, professors[classes[students[i].class_choice[j]].profnumber].name,
		   classes[students[i].class_choice[j]].room, 
		   classes[students[i].class_choice[j]].time);
	  }
	printf("\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n");
      }
#endif
    fflush(stdout);
  }
